#ifndef _WINO_MACRO_H_
#define _WINO_MACRO_H_


#define NEEDS_BIT(N, B)     (N > (1<<B) ? 1:0 )

#define LOG2CEIL(N)                            \
        (NEEDS_BIT(N,  0) + NEEDS_BIT(N,  1) + \
         NEEDS_BIT(N,  2) + NEEDS_BIT(N,  3) + \
         NEEDS_BIT(N,  4) + NEEDS_BIT(N,  5) + \
         NEEDS_BIT(N,  6) + NEEDS_BIT(N,  7) + \
         NEEDS_BIT(N,  8) + NEEDS_BIT(N,  9) + \
         NEEDS_BIT(N, 10) + NEEDS_BIT(N, 11) + \
         NEEDS_BIT(N, 12) + NEEDS_BIT(N, 13) + \
         NEEDS_BIT(N, 14) + NEEDS_BIT(N, 15) \
        /* NEEDS_BIT(N, 16) + NEEDS_BIT(N, 17) + \
         NEEDS_BIT(N, 18) + NEEDS_BIT(N, 19) + \
         NEEDS_BIT(N, 20) + NEEDS_BIT(N, 21) + \
         NEEDS_BIT(N, 22) + NEEDS_BIT(N, 23) + \
         NEEDS_BIT(N, 24) + NEEDS_BIT(N, 25) + \
         NEEDS_BIT(N, 26) + NEEDS_BIT(N, 27) + \
         NEEDS_BIT(N, 28) + NEEDS_BIT(N, 29) + \
         NEEDS_BIT(N, 30) + NEEDS_BIT(N, 31)  */ \
        )



#define AP_INT_MAX_W 1152
#define BATCH_SIZE 2

#define INPUT_FEED_NUMBER 2

#define WINO5x5_EN 1
#define WINO3x3_EN 1





#define WINO_DOMAIN_SIZE 6
#define WINO_DOMAIN_SIZE_SQUARE (WINO_DOMAIN_SIZE*WINO_DOMAIN_SIZE)


#if WINO_DOMAIN_SIZE == 4


#elif WINO3x3_EN
#define WINO_OUT_SIZE 4
#define WINO_OUT_SIZE_SQUARE (WINO_OUT_SIZE * WINO_OUT_SIZE)
#else
#define WINO_OUT_SIZE 2
#define WINO_OUT_SIZE_SQUARE (WINO_OUT_SIZE * WINO_OUT_SIZE)
#endif

#define INPUT_BUFFER_DEPTH_BITWIDTH 10
#define INPUT_BUFFER_DEPTH (1<<INPUT_BUFFER_DEPTH_BITWIDTH)


#define OUTPUT_BUFFER_DEPTH_BITWIDTH 10
#define OUTPUT_BUFFER_DEPTH (1<<OUTPUT_BUFFER_DEPTH_BITWIDTH)

#define WEIGHT_BUFFER_DEPTH_BITWIDTH 10
#define WEIGHT_BUFFER_DEPTH (1<<WEIGHT_BUFFER_DEPTH_BITWIDTH)



#define WINO_HEIGHT 8
#define WINO_HEIGHT_BITWIDTH LOG2CEIL(WINO_HEIGHT)

#define WINO_WIDTH 4
#define WINO_WIDTH_BITWIDTH LOG2CEIL(WINO_WIDTH)


#define INBUFFER_WIDTH_BITWIDTH LOG2CEIL(2+4*WINO_WIDTH)
#define INBUFFER_WIDTH (1<<INBUFFER_WIDTH_BITWIDTH)

#define INBUFFER_HEIGHT_BITWIDTH 3
#define INBUFFER_HEIGHT (1<<INBUFFER_HEIGHT_BITWIDTH)




#define INDEPTH_MINITILE_SIZE_BITWIDTH 2
#define INDEPTH_MINITILE_SIZE (1<<INDEPTH_MINITILE_SIZE_BITWIDTH)
#define OUTDEPTH_MINITILE_SIZE_BITWIDTH WINO_HEIGHT_BITWIDTH
#define OUTDEPTH_MINITILE_SIZE (1<<OUTDEPTH_MINITILE_SIZE_BITWIDTH)


#define WEIGHT_FEED_NUMBER_PER_PORT (WINO_HEIGHT/4)
#define WEIGHT_FEED_NUMBER_PER_PORT_BITWIDTH (WINO_HEIGHT_BITWIDTH-2)

#define INBUFFER_MID_ADDR_BITWIDTH (INPUT_BUFFER_DEPTH_BITWIDTH-1-INDEPTH_MINITILE_SIZE_BITWIDTH)

#define WEIGHTDDR_INDEPTH_MINITILE_128BIT_STEP  CEIL_DIV(WINO_DOMAIN_SIZE_SQUARE*INDEPTH_MINITILE_SIZE,16)
#define WEIGHTDDR_INDEPTH_MINITILE_128BIT_STEP_BITWIDTH LOG2CEIL(WEIGHTDDR_INDEPTH_MINITILE_128BIT_STEP)





#define IN_WIDTH 8
#define W_WIDTH 8

#define DB_QUANT_BIT 0
#define DB_WIDTH (IN_WIDTH+4-DB_QUANT_BIT)

#define BTB_QUANT_BIT 0
#define BTB_WIDTH (DB_WIDTH+4-BTB_QUANT_BIT)



#define UV_QUANT_BIT 0
#define UV_MUL_WIDTH (BTB_WIDTH+W_WIDTH+1)
#define UV_WIDTH (BTB_WIDTH+W_WIDTH+INDEPTH_MINITILE_SIZE_BITWIDTH-UV_QUANT_BIT)



#define UVA_QUANT_BIT 0
#define UVA_WIDTH (UV_WIDTH+5-UVA_QUANT_BIT)



#define ATA_QUANT_BIT 0
#define ATA_WIDTH (UVA_WIDTH+5-ATA_QUANT_BIT)



#define DEBUG_FILE_PRINT 1

#if DEBUG_FILE_PRINT
#include "../testbench/debug.hpp"
#endif

#endif
